package flex.samples.web.logic
{
import flash.events.MouseEvent;

import flex.samples.dto.HelloWorldRequestDto;
import flex.samples.dto.HelloWorldResponseDto;
import flex.samples.entity.Test;
import flex.samples.logic.Logic;
import flex.samples.web.HelloWorldForm;

import mx.collections.ArrayCollection;
import mx.events.FlexEvent;
import mx.rpc.events.FaultEvent;
import mx.rpc.events.ResultEvent;
import mx.utils.ArrayUtil;
    
/**
 * HelloWorldのLogicクラスです。
 */
public class HelloWorldLogic extends Logic {
//--------------------------------------
//  Variables
//--------------------------------------

//--------------------------------------
//  Constructor
//--------------------------------------
    /**
     * コンストラクタ
     */
    public function HelloWorldLogic() {
        super();
    }

//--------------------------------------
//  Initialization
//--------------------------------------

    /**
     * onCreationCompleteHandler
     */
    override protected function onCreationCompleteHandler(event:FlexEvent):void {
    }
    
//--------------------------------------
//  UI Event Handler
//--------------------------------------
    
    /**
     * Helloボタンのクリックイベント
     * 
     * @param event MouseEvent
     */
    public function onHelloButtonClickHandler(event:MouseEvent):void {
        // リモートメソッド呼び出し用の検索条件を作成
        var test:Test = new Test();
        test.id = 777;
        
        // DTOの準備
        var requestDto:HelloWorldRequestDto = new HelloWorldRequestDto();
        requestDto.test = test;
        
        // 配列送信のテスト（World!取得処理とは無関係です！）
        var testList:ArrayCollection = new ArrayCollection();
        testList.addItem(new Test());
        testList.addItem(new Test());
        requestDto.testList = testList;
        
        // リモートメソッドを呼び出す
        view.srv.getWorld(requestDto);
    }
    
    /**
     * getWorld処理の結果イベント
     * 
     * @param event ResultEvent
     */
    public function onGetWorldResult(event:ResultEvent):void {
        // DTOを取得
        var responseDto:HelloWorldResponseDto = event.result as HelloWorldResponseDto;
        
        // 結果を取得
        var test:Test = responseDto.test;

        // 処理結果を画面に反映
        view.worldLable.text = test.name;
    }
    
    /**
     * Listボタンのクリックイベント
     * 
     * @param event MouseEvent
     */
    public function onListButtonClickHandler(event:MouseEvent):void {
        // リモートメソッドを呼び出す
        view.srv.getList();
    }

    /**
     * getList処理の結果イベント
     * 
     * @param event ResultEvent
     */
    public function onGetListResult(event:ResultEvent):void {
        // DTOを取得
        var list1:ArrayCollection = ArrayCollection(event.result); // これでいけます
        var list2:ArrayCollection = ArrayCollection(ArrayUtil.toArray(event.result)); // これでいけます
    }

    /**
     * リモート呼び出しの失敗イベント（共通）
     */
    public function onFault(event:FaultEvent):void {
        trace(event);
    }
    
//--------------------------------------
//  Function
//--------------------------------------

//--------------------------------------
//  View-Logic Binding
//--------------------------------------
    /** 画面 */
    public var _view:HelloWorldForm;
    
    /**
     * 画面を取得します
     */     
    public function get view():HelloWorldForm {
        if (_view == null) {
            _view = super.document as HelloWorldForm;
        }
        return _view;
    }
    
    /**
     * 画面をセットします。
     * 
     * @param view セットする画面
     */
    public function set view(view:HelloWorldForm):void {
        _view = view;
    }
}
}