package jp.co.atmarkit.quiz.entity
{
import mx.collections.ArrayCollection;
    

[Bindable]
[RemoteClass(alias="jp.co.atmarkit.quiz.entity.Quiz")]
/**
 * クイズテーブルに対応したエンティティ
 */
public class Quiz {
    /** 問題 */
    public var question:String;
    
    /** 選択肢 */
    public var selectors:String;
    
    /** 解答 */
    public var correct:String;
    
    /** 選択肢（Array型） */
    public function get selector():Array {
        if(selectors != null && selectors != "") {
            return selectors.split(",");
        } else {
            return null;
        }
    }
    
    /**
     * XMLからTQuizを生成する
     * 
     * @param xml 入力XML
     * @return TQuiz
     */
    public static function populate(xml:XML):Quiz {
        var quiz:Quiz = new Quiz();
        
        if(xml.question) {
            quiz.question = String(xml.question).replace(/\\n/g, "\n").replace(/\\t/g, "\t");    
        }

        if(xml.selectors) {
            quiz.selectors = xml.selectors;    
        }

        if(xml.correct) {
            quiz.correct = xml.correct;    
        }
        
        return quiz;
    }
}
}