package jp.co.atmarkit.user.entity {
    import flash.utils.describeType;
    

/**
 * Userエンティティ
 */
[Bindable]
[RemoteClass(alias="jp.co.atmarkit.user.entity.User")]
public class User {
    
    /** XMLのデフォルトファイル名です。 */
    public static const XML_DEFAULT_FILE_NAME:String = "users.xml";

    /** XMLのルート開始タグです。 */
    public static const ROOT_START_TAG:String = "<users>";

    /** XMLのルート終了タグです。 */
    public static const ROOT_END_TAG:String = "</users>";

    /** id */
    public var id:uint;
    /** name */
    public var name:String;
    /** ruby */
    public var ruby:String;
    /** mail */
    public var mail:String;
    /** sex */
    public var sex:String;
    /** age */
    public var age:String;
    /** birthday */
    public var birthday:String;
    /** married */
    public var married:String;
    /** bloodtype */
    public var bloodtype:String;
    /** prefecture */
    public var prefecture:String;
    /** prefectureCode */
    public var prefectureCode:String;
    /** phone */
    public var phone:String;
    /** keitai */
    public var keitai:String;
    /** carrier */
    public var carrier:String;
    /** curry */
    public var curry:String;

    /**
     * populate
     * 
     * @param value XML状のUser
     * @return User
     */
    public static function populate(value:Object):User {
        // nullの場合はnullを返す
        if(value == null) {
            return null;
        }
        
        var returnValue:User = new User();
        
        // id
        if(value.id != null) {
            returnValue.id = uint(value.id);
        }

        // name
        if(value.name != null) {
            returnValue.name = String(value.name);
        }
        
        // ruby
        if(value.ruby != null) {
            returnValue.ruby = String(value.ruby);
        }
        
        // mail
        if(value.mail != null) {
            returnValue.mail = String(value.mail);
        }

        // sex
        if(value.sex != null) {
            returnValue.sex = String(value.sex);
        }

        // age
        if(value.age != null) {
            returnValue.age = String(value.age);
        }

        // birthday
        if(value.birthday != null) {
            returnValue.birthday = String(value.birthday);
        }

        // married
        if(value.married != null) {
            returnValue.married = String(value.married);
        }

        // bloodtype
        if(value.bloodtype != null) {
            returnValue.bloodtype = String(value.bloodtype);
        }

        // prefecture
        if(value.prefecture != null) {
            returnValue.prefecture = String(value.prefecture);
        }

        // prefectureCode
        if(value.prefectureCode != null) {
            returnValue.prefectureCode = String(value.prefectureCode);
        }

        // phone
        if(value.phone != null) {
            returnValue.phone = String(value.phone);
        }

        // keitai
        if(value.keitai != null) {
            returnValue.keitai = String(value.keitai);
        }

        // carrier
        if(value.carrier != null) {
            returnValue.carrier = String(value.carrier);
        }

        // curry
        if(value.curry != null) {
            returnValue.curry = String(value.curry);
        }

        return returnValue;
    }
    
    /**
     * toXMLString
     * 
     * @return String
     */
    public function toXMLString():String {
        
        if(this == null) {
            return null;
        }
        
        var returnValue:String =
            "<user " + 
            "id=\"" + this.id + "\" " +
            "name=\"" + this.name + "\" " +
            "ruby=\"" + this.ruby + "\" " +
            "mail=\"" + this.mail + "\" " +
            "sex=\"" + this.sex + "\" " +
            "age=\"" + this.age + "\" " +
            "birthday=\"" + this.birthday + "\" " +
            "married=\"" + this.married + "\" " +
            "bloodtype=\"" + this.bloodtype + "\" " +
            "prefecture=\"" + this.prefecture + "\" " +
            "prefectureCode=\"" + this.prefectureCode + "\" " +
            "phone=\"" + this.phone + "\" " +
            "keitai=\"" + this.keitai + "\" " +
            "carrier=\"" + this.carrier + "\" " +
            "curry=\"" + this.curry + "\" " +
            "/>";
            
        return returnValue;
    }
}
}