package jp.co.atmarkit.quiz.service;

import jp.co.atmarkit.quiz.dto.QuizRequestDto;
import jp.co.atmarkit.quiz.dto.QuizResponseDto;
import jp.co.atmarkit.quiz.jdbc.CommentJdbc;
import jp.co.atmarkit.quiz.jdbc.QuizJdbc;

import org.seasar.framework.container.annotation.tiger.Binding;


/**
 * QuizServiceクラスです。
 */
public class QuizService {

    /** {@link QuizJdbc} */
    @Binding
    public QuizJdbc quizJdbc;

    /** {@link CommentJdbc} */
    @Binding
    public CommentJdbc commentJdbc;

    /**
	 * 設問とコメントを返します。
	 * 
	 * @param requestDto {@link QuizRequestDto}
	 * @return {@link QuizResponseDto}
	 */
	public QuizResponseDto getQuiz(QuizRequestDto requestDto) {
	    // 戻り値の作成
	    QuizResponseDto responseDto = new QuizResponseDto();
	    
	    // 設問の検索の実行
	    responseDto.quizList = quizJdbc.getQuiz();
	    
        // コメントの検索の実行
        responseDto.commentList = commentJdbc.getComment();
        
	    // 検索結果をクライアントに返す
	    return responseDto;
	}
}